#ifndef __RIBPCI_HARDWARE_H__
#define __RIBPCI_HARDWARE_H__

#if defined(WIN32)
#pragma message ("WIN32 defined.")
#elif defined(LINUX)
#pragma message ("LINUX defined.")
#elif defined(WIN40)
#pragma message ("WIN40 defined.")
#elif defined(WINDOWS)
#pragma message ("WINDOWS defined.")
#elif defined(VXD_DRIVER)
#pragma message ("VXD_DRIVER defined.")
#else
#pragma message ("No platform definition found.")
#endif

#if defined(VXD_DRIVER) || defined(WIN32)
#include "RibDef.h"
#endif

#define RIB_PCI_VER					0x0203
//Notice: the JWRIBPCI_HARDWARE_VERSION	definition is in RibDef.h

#define	JWRIBPCI_VENDORID			JWRIBPCI_V0100_VENDORID
#define	JWRIBPCI_DEVICEID			JWRIBPCI_V0100_DEVICEID
#define	JWRIBPCI_SUBVENDORID		JWRIBPCI_V0100_SUBVENDORID

#define	JWRIBPCI_V0100_VENDORID		0x136C
#define	JWRIBPCI_V0100_DEVICEID		0xC0C0
#define	JWRIBPCI_V0100_SUBVENDORID	0x574A	//JW

#define JWRIBPCI_LCR_SIZE		16
#define JWRIBPCI_IO_SIZE		256



#if defined(VXD_DRIVER) || defined(WIN32)
#define	IO_ADR_TYPE		WORD
#define	INPUT_FUNC		_inpw
#define	OUTPUT_FUNC		_outw
#else
#define	IO_ADR_TYPE		//(WORD)
#endif
// in macro, (i) specify the board number(0..MAX_RIB_NUM-1)
#define	DECLARE_RIB_PCI_BASEADR			DWORD RIB_PCI_BASEADR[MAX_RIB_NUM]={0}
#define	DECLARE_RIB_PCI_BASELCR			DWORD RIB_PCI_BASELCR[MAX_RIB_NUM]={0}
#define	EXTERN_DECLARE_RIB_PCI_BASEADR	extern DWORD RIB_PCI_BASEADR[MAX_RIB_NUM]
#define	EXTERN_DECLARE_RIB_PCI_BASELCR	extern DWORD RIB_PCI_BASELCR[MAX_RIB_NUM]

//PIO chip1: IOCS8, offset 0x60
#define	PIO_IC1			0x60
#define	PIO1_PORT1(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1)
#define	PIO1_PORT2(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 2)
#define	PIO1_PORT3(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 4)
#define	PIO1_PORT4(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 6)
#define	PIO1_PORT5(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 8)
#define	PIO1_PORT6(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 10)
#define	PIO1_PORT7(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 12)
#define	PIO1_PORT8(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 14)
#define	PIO1_PORT9(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 16)
#define	PIO1_CR0(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 18)	// write only
#define	PIO1_CR1(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 20)	// write only
#define	PIO1_CR2(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 22)	// write only
#define	PIO1_CR3(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC1 + 24)	// write only

//PIO	chip2:	IOCS11, offset 0xC0
#define	PIO_IC2			0xC0
#define	PIO2_PORT1(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2)
#define	PIO2_PORT2(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 2)
#define	PIO2_PORT3(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 4)
#define	PIO2_PORT4(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 6)
#define	PIO2_PORT5(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 8)
#define	PIO2_PORT6(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 10)
#define	PIO2_PORT7(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 12)
#define	PIO2_PORT8(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 14)
#define	PIO2_PORT9(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 16)
#define	PIO2_CR0(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 18)	// write only
#define	PIO2_CR1(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 20)	// write only
#define	PIO2_CR2(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 22)	// write only
#define	PIO2_CR3(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PIO_IC2 + 24)	// write only

//DA	chip1:	IOCS02, offset 0x20
#define	DA_IC1			0x20
#define	DA1_CH1(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC1)
#define	DA1_CH2(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC1 + 2)
#define	DA1_CH3(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC1 + 4)
#define	DA1_CH4(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC1 + 6)
#define	DA1_CH5(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC1 + 8)
#define	DA1_CH6(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC1 + 10)
#define	DA1_CH7(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC1 + 12)
#define	DA1_CH8(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC1 + 14)

//DA	chip2:	IOCS03, offset 0x30
#define	DA_IC2			0x30
#define	DA2_CH1(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC2)
#define	DA2_CH2(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC2 + 2)
#define	DA2_CH3(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC2 + 4)
#define	DA2_CH4(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC2 + 6)
#define	DA2_CH5(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC2 + 8)
#define	DA2_CH6(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC2 + 10)
#define	DA2_CH7(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC2 + 12)
#define	DA2_CH8(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + DA_IC2 + 14)

#define DA_XLD1			0xA8
#define DA_XLD2			0xAA
#define	DA_STARTLINE1(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i]+DA_XLD1)
#define	DA_STARTLINE2(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i]+DA_XLD2)
#define	DA_START(i)			_outpw(DA_STARTLINE2(i), 0)
//#define	DA_START(i)		_outpw(RIB_PCI_BASEADR[i]+DA_XLD2, 0)

//AD chip1:		IOCS00, offset 0x00
#define	AD_IC1			0x00
#define	AD1_DATA(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + AD_IC1)

//AD chip2:		IOCS01, offset 0x10
#define	AD_IC2			0x10
#define	AD2_DATA(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + AD_IC2)
//#define AD12_DATA	0x20
#define	AD_CH1			0x00
#define	AD_CH2			0x08
#define	AD_CH3			0x10
#define	AD_CH4			0x18
#define	AD_CH5			0x20
#define	AD_CH6			0x28
#define	AD_CH7			0x30
#define	AD_CH8			0x38
#define	AD_START		0x04
#define AD_STANDBY		0x02
#define AD_FORMAT		0x01

#define AD1_EOC_LINE(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + 0xA6)
#define	AD1_EOC_MASK(i)	0x0001
#define AD2_EOC_LINE(i)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + 0xA6)
#define	AD2_EOC_MASK(i)	0x0002
#define AD1_EOC(i)		(_inpw(AD1_EOC_LINE(i)) & AD1_EOC_MASK(i))
#define AD2_EOC(i)		(_inpw(AD2_EOC_LINE(i)) & AD2_EOC_MASK(i))

//ENC
#define ENC_MAXIC				8
#define	ENC_IC_OFFSET_DEFINE	{0x40, 0x48, 0x50, 0x58, 0xE0, 0xE8, 0xF0, 0xF8}
#define	DECLARE_ENC_IC_OFFSET	const WORD ENC_IC_OFFSET[ENC_MAXIC]=ENC_IC_OFFSET_DEFINE
#define ENC_IC_ADR(i, encic)	(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + ENC_IC_OFFSET[encic])

#if JWRIBPCI_HARDWARE_VERSION==0x0102	// no enc phase registers, used by pwm clock high bits.
#else
#define ENC_ZPHASE_OFFSET		0xA2	//  ENC Z-Phase Enable
#define ENC_ZPHASE(i)			(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + ENC_ZPHASE_OFFSET)
#endif
//#define ENC_ZPOLE_OFFSET		0xA4	//  see INT_POLARITY_OFFSET
//#define ENC_ZPOLE(i)			(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + ENC_ZENABLE_OFFSET)

#define ENC_CMDADR				0x00	//  Write command  
#define ENC_STAADR				0x00	//  Read status
#define ENC_DATA1				0x02	//  2^23-2^16  High byte:	xxxx--------
#define ENC_DATA2				0x04	//  2^15-2^08  Middle byte:----xxxx----
#define ENC_DATA3				0x06	//  2^07-2^00  Low byte:	--------xxxx

#define ENC_PULSEMODE			0x10
#define ENC_2PHASEX1MODE		0x11
#define ENC_2PHASEX2MODE		0x12
#define ENC_2PHASEX4MODE		0x13

//PWM
//PWM chip:	offset 0x80 -- 0x9E
//DATA(for special version): Low byte--clock data, Hight byte--duty data.
#define PWM_DATA_OFFSET			0x80
#define	PWM_DATA_CH0(i)			(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PWM_DATA_OFFSET)
#define	PWM_ENABLE_OFFSET		0xA0
#define	PWM_ENABLE(i)			(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PWM_ENABLE_OFFSET)
#if JWRIBPCI_HARDWARE_VERSION==0x0102	// 
#define PWM_CLKHBIT_OFFSET		0xA2	// 
#define PWM_CLKHBIT(i)			(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + PWM_CLKHBIT_OFFSET)
#else									// see enc zhpase
#endif

//INT
#define	MAX_RIB_EXT_INT		4
#define INT_POLARITY_OFFSET	0xA4
#define	INT_POLARITY(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + INT_POLARITY_OFFSET)
		//b0,b1,b2,b3: external irq polarity, b7: ENC Zphase polarity.
		//0:low active, 1:high active

#if	JWRIBPCI_HARDWARE_VERSION<0x0300
#define	INT_OUTER_INT		0
#endif

#define	INT_ENC_ZPHASE		1
#define	IRQ_ACTIVE_LOW		0
#define	IRQ_ACTIVE_HIGH		1

#if	JWRIBPCI_HARDWARE_VERSION<0x0300
#define	INT_STATUS_OFFSET	0xA6	//b2-b5
#define	INT_STATUS(i)		(IO_ADR_TYPE)(RIB_PCI_BASEADR[i] + INT_STATUS_OFFSET)
#define	INT_STATUS_MASK		0x3C	//bit2 - bit5
#endif

#endif	//__RIBPCI_HARDWARE_H
