// RobotTimIntDlg.cpp : implementation file
//

#include "stdafx.h"
#include "robotctrl.h"
#include "RobotTimIntDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern UINT WM_IrqMsg; /*=RegisterWindowsMessage("JwRib Irq Message Id")*/
/////////////////////////////////////////////////////////////////////////////
// CRobotTimIntDlg dialog


CRobotTimIntDlg::CRobotTimIntDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRobotTimIntDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRobotTimIntDlg)
	m_nTim0 = 100;
	m_nTim1 = 100;
	m_bEnableGraph = FALSE;
	//}}AFX_DATA_INIT
}


void CRobotTimIntDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRobotTimIntDlg)
	DDX_Control(pDX, IDC_INTTYPE, m_IntTypeEdit);
	DDX_Control(pDX, IDC_INT_COUNTER, m_CountEdit);
	DDX_Control(pDX, IDC_INTSTATIC3, m_IntStatic3);
	DDX_Control(pDX, IDC_INTSTATIC2, m_IntStatic2);
	DDX_Control(pDX, IDC_INTSTATIC1, m_IntStatic1);
	DDX_Control(pDX, IDC_INTSTATIC0, m_IntStatic0);
	DDX_Control(pDX, IDC_TIMSLIDER1, m_TimSlider1);
	DDX_Control(pDX, IDC_TIMEDIT1, m_TimEdit1);
	DDX_Control(pDX, IDC_TIMSTATIC1, m_TimStatic1);
	DDX_Control(pDX, IDC_TIMEDIT0, m_TimEdit0);
	DDX_Control(pDX, IDC_TIMSLIDER0, m_TimSlider0);
	DDX_Control(pDX, IDC_TIMSTATIC0, m_TimStatic0);
	DDX_Text(pDX, IDC_TIMEDIT0, m_nTim0);
	DDV_MinMaxInt(pDX, m_nTim0, 0, 65535);
	DDX_Text(pDX, IDC_TIMEDIT1, m_nTim1);
	DDV_MinMaxInt(pDX, m_nTim1, 0, 65535);
	DDX_Check(pDX, IDC_ENABLEGRAPH, m_bEnableGraph);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRobotTimIntDlg, CDialog)
	//{{AFX_MSG_MAP(CRobotTimIntDlg)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_TIMSTART1, OnTimstart1)
	ON_BN_CLICKED(IDC_TIMSTART0, OnTimstart0)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_EN_KILLFOCUS(IDC_TIMEDIT0, OnKillfocusTimedit0)
	ON_EN_KILLFOCUS(IDC_TIMEDIT1, OnKillfocusTimedit1)
	ON_BN_CLICKED(IDC_ENABLEMSG, OnEnablemsg)
	ON_BN_CLICKED(IDC_ENABLEGRAPH, OnEnablegraph)
	ON_BN_CLICKED(IDC_EXT_INT_EDGE0, OnExtIntEdge0)
	ON_BN_CLICKED(IDC_EXT_INT_EDGE1, OnExtIntEdge1)
	ON_BN_CLICKED(IDC_EXT_INT_EDGE2, OnExtIntEdge2)
	ON_BN_CLICKED(IDC_EXT_INT_EDGE3, OnExtIntEdge3)
	ON_BN_CLICKED(IDC_EXT_INT_POLARITY0, OnExtIntPolarity0)
	ON_BN_CLICKED(IDC_EXT_INT_POLARITY1, OnExtIntPolarity1)
	ON_BN_CLICKED(IDC_EXT_INT_POLARITY2, OnExtIntPolarity2)
	ON_BN_CLICKED(IDC_EXT_INT_POLARITY3, OnExtIntPolarity3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRobotTimIntDlg message handlers

void CRobotTimIntDlg::OnCustomDrawTim(int ch, BOOL bFullDraw/*=FALSE*/)
{
	RECT rect, rc;
	//RECT Updaterc;
	CBrush *pCurBrush;
	int nCurCounter;
	int MaxGrid=49;

	RECT rec;
	int recti;

	rec.top=0;
	recti=2;
	if ( (ch>=INT_EXT1) && (ch<=INT_EXT4) )
	{
		ch -= INT_EXT1;
		pCurBrush = pGreenBrush;
		m_apIntStatic[ch]->GetWindowRect(&rect);
		nCurCounter=m_IntCounter[ch];
		if ((nCurCounter>MaxGrid) || (nCurCounter<0))
			nCurCounter=m_IntCounter[ch]=0;
	}
	/*else if ( (ch>=INT_TM1) && (ch<=INT_TM2) )
	{
		ch -= INT_TM1;
		pCurBrush = pRedBrush;
		m_apTimStatic[ch]->GetWindowRect(&rect);
		nCurCounter=m_TimCounter[ch];
		if ((nCurCounter>MaxGrid) || (nCurCounter<0))
			nCurCounter=m_TimCounter[ch]=0;
	}*/
	else
		return;

	ScreenToClient( &rect );
	//if (!GetUpdateRect(&Updaterc) || !IntersectRect(NULL, &rect, &Updaterc) )
	//	return;
 
 	CClientDC dc(this);
 
	pOldPen = dc.SelectObject(pBlackPen);
	pOldBrush = dc.SelectObject(pCurBrush);

	//dc.Rectangle(&rect);
	rc.left=rect.left;	rc.right=rect.right;
	int nVstep=(rect.bottom-rect.top)/MaxGrid;
	rect.top=rect.bottom-nVstep*MaxGrid;

	if (bFullDraw)
	{
		rc.bottom=rect.bottom;
		for (int i=0; i<nCurCounter; i++)
		{
			rc.top=rc.bottom-nVstep;
			dc.Rectangle(&rc);
			rc.bottom=rc.top;
		}
		rc.top = rect.top;
		dc.SelectObject(pOldBrush);
		dc.Rectangle(&rc);
	}
	else	//  Increment draw
	{
		if (nCurCounter>0)
		{
			rc.bottom=rect.bottom-nVstep*(nCurCounter-1);
			rc.top=rc.bottom-nVstep;
			dc.Rectangle(&rc);
		}
		else	// nCurCounter == 0, clear it.
		{
			dc.SelectObject(pOldBrush);
			dc.Rectangle(&rect);
		}
	}


	dc.SelectObject(pOldPen);
	dc.SelectObject(pOldBrush);
	//ReleaseDC(&dc);
}

void CRobotTimIntDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	OnCustomDrawTim(INT_EXT1, TRUE);
	OnCustomDrawTim(INT_EXT2, TRUE);
	OnCustomDrawTim(INT_EXT3, TRUE);
	OnCustomDrawTim(INT_EXT4, TRUE);
//	OnCustomDrawTim(INT_TM1, TRUE);
//	OnCustomDrawTim(INT_TM2, TRUE);

	// Do not call CDialog::OnPaint() for painting messages
}

void CRobotTimIntDlg::OnOK() 
{
	CDialog::OnOK();
}


BOOL CRobotTimIntDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_apTimStatic[0]=&m_TimStatic0;	m_apTimStatic[1]=&m_TimStatic1;
	m_apIntStatic[0]=&m_IntStatic0;	m_apIntStatic[1]=&m_IntStatic1;
	m_apIntStatic[2]=&m_IntStatic2;	m_apIntStatic[3]=&m_IntStatic3;

	m_apTimSlider[0]=&m_TimSlider0;	m_apTimSlider[1]=&m_TimSlider1;
	m_apTimEdit[0]=&m_TimEdit0;		m_apTimEdit[1]=&m_TimEdit1;
	m_apnTim[0]=&m_nTim0;	m_apnTim[1]=&m_nTim1;

	for (int i=0; i<2; i++)
	{
		m_apTimSlider[i]->SetRange(0, 60000);
		m_apTimSlider[i]->SetPageSize(100);
		m_apTimSlider[i]->SetLineSize(10);
		m_apTimSlider[i]->SetPos(m_nTim0);
		m_apTimSlider[i]->SetTicFreq(1000);
		m_apTimEdit[i]->SetLimitText(5);
		m_abTimStart[i]=FALSE;
	}

	memset(m_IntCounter, 0, sizeof(m_IntCounter));

	m_aiExtIntEnId[0]=IDC_EXTINTEN0;	m_aiExtIntEnId[1]=IDC_EXTINTEN1;
	m_aiExtIntEnId[2]=IDC_EXTINTEN2;	m_aiExtIntEnId[3]=IDC_EXTINTEN3;
	for (i=0; i<4; i++)
		m_abExtInt[i] = FALSE;

	pBlackPen = new CPen(PS_SOLID, 1, (COLORREF)0);
	pRedBrush = new CBrush((COLORREF)0x000000FF);
	pGreenBrush = new CBrush((COLORREF)0x0000FF00);

	bEnableIntMsg=FALSE;
	m_bEnableGraph = FALSE;
	//StopTimer(0);
	//StopTimer(1);
	IntDisable(0);
	IntDisable(1);
	IntDisable(2);
	IntDisable(3);
	EnableIntMsg(FALSE);

	IntMode(-1, 1);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRobotTimIntDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	int i;
	for (i=0; i<2; i++)
		if ( (int)pScrollBar==(int)m_apTimSlider[i] )
		{
			OnTimSlider(i);
			return;
		}
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CRobotTimIntDlg::OnTimSlider(int ch)
{
	int data;
	char str[64];

	data = m_apTimSlider[ch]->GetPos();
	if (*m_apnTim[ch]!=data)
	{
		*m_apnTim[ch]=data;
		m_apTimEdit[ch]->SetWindowText(itoa(data, str, 10));
	}
}

void CRobotTimIntDlg::OnTimstart1() 
{
	OnTimStart(1);
}

void CRobotTimIntDlg::OnTimstart0() 
{
	OnTimStart(0);
}

void CRobotTimIntDlg::OnTimStart(int ch)
{
	//STWIN_STATUS MpuStatus;

	m_abTimStart[ch]^=TRUE;

	m_apTimSlider[ch]->EnableWindow(!m_abTimStart[ch]);
	m_apTimEdit[ch]->EnableWindow(!m_abTimStart[ch]);
	if (m_abTimStart[ch])
	{
		SendCmdEx(0, 0, CMD_INT_CLEAR);
		StartTimer(ch, *m_apnTim[ch]);
	}
	else
	{
		StopTimer(ch);
	}
}

void CRobotTimIntDlg::OnDestroy() 
{
	CDialog::OnDestroy();

	delete pBlackPen;
	delete pRedBrush;
	delete pGreenBrush;
}

LRESULT CRobotTimIntDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (message==WM_IrqMsg)
		return OnIrqMsg(wParam, lParam);

	return CDialog::WindowProc(message, wParam, lParam);
}

//..<<
LRESULT CRobotTimIntDlg::OnIrqMsg(WPARAM wParam, LPARAM lParam)
{	// wParam is INTTYPE,
	// lParam is the counter of all interrupts received by PC.
	TCHAR str[256];
	int i, tmp;
	//PRIB_INT_INFO	pstIntInfo=(PRIB_INT_INFO)lParam;
	//ASSERT(pstIntInfo);
	//PRIB_INT_QUEUE  pstIntQ=(PRIB_INT_QUEUE)pstIntInfo->dwReserved1;
	//ASSERT(pstIntQ);
	//ASSERT(pstIntQ->dwMaxNum);

	SendCmdEx(0, 0, CMD_INT_CLEAR);		// clear INTFLAG and
										// next int message can be sent

	//for (i=0; i<16; i++)				// You can do some thing here like this.
	//	DaWriteData(i, 0);

	//if (!m_bEnableGraph)					// Disable graph can increse dispose speed
	//	return 0;						// when timer is less than 2ms,
										// graph is recommended be disabled

	//tmp = pstIntQ->dwHead - pstIntQ->dwRear;
	//if (tmp<0)	tmp+=pstIntQ->dwMaxNum;
	//tmp = (int)(tmp*100.0/(pstIntQ->dwMaxNum-1));
	//for(i=2; i>=0; i--, tmp/=10)
	//	str[i]=tmp%10 + _T('0');
	//str[3]=_T('\0');
	//SetDlgItemText(IDC_INT_BUF_USE, str);

	for (i=7, tmp=wParam; i>=0; i--, tmp>>=1)
		str[i]=(tmp&0x01)+'0';
	str[8]=0;
	m_IntTypeEdit.SetWindowText(str);		// Display Int Num
	itoa(lParam, str, 10);
	m_CountEdit.SetWindowText(str);			// Display Int Counter

	// Disable graph can use much less CPU time, when IRQ frequence is more than 500Hz, graph is recommended to be disabled.
	if (!m_bEnableGraph)					
	{
		//PostMessage(WM_PAINT);
		return 0;
	}

	if ( (wParam>=INT_EXT1) && (wParam<=INT_EXT4) )
	{
		m_IntCounter[wParam-INT_EXT1]++;
		OnCustomDrawTim(wParam);
	}
	//else if( (wParam>=INT_TM1) && (wParam<=INT_TM2) )
	//{
	//	m_TimCounter[wParam-INT_TM1]++;
	//	OnCustomDrawTim(wParam);
	//}
	return 0;
}

BOOL CRobotTimIntDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	int i;
	for (i=0; i<4; i++)
	{
		if (m_aiExtIntEnId[i]==int(wParam&0x0000FFFF))
			return OnExtIntEn(i);
	}
	
	return CDialog::OnCommand(wParam, lParam);
}

BOOL CRobotTimIntDlg::OnExtIntEn(int ch)
{
	m_abExtInt[ch] ^= TRUE;
	if (m_abExtInt[ch])
		IntEnable(ch);
	else
		IntDisable(ch);
	return TRUE;
}

void CRobotTimIntDlg::OnKillfocusTimedit0() 
{
	OnKillFocusTimEdit(0);
}

void CRobotTimIntDlg::OnKillfocusTimedit1() 
{
	OnKillFocusTimEdit(1);
}

void CRobotTimIntDlg::OnKillFocusTimEdit(int ch)
{
	if (UpdateData())
	{
		m_apTimSlider[ch]->SetPos(*m_apnTim[ch]);
	}

}

void CRobotTimIntDlg::OnEnablemsg() 
{
	//RIB_STATUS MpuStatus;
	if (!bEnableIntMsg)
	{
		if (SetWndMsg(m_hWnd, WM_IrqMsg))
		{
			CheckDlgButton(IDC_ENABLEMSG, FALSE);
			return;	// fail
		}
		//	Notify VxD to send message to this hWnd,
		//  normally you should enable message here before open any timer or ext int
		if (EnableIntMsg(TRUE))
		{
			CheckDlgButton(IDC_ENABLEMSG, FALSE);
			return;	// fail
		}
		bEnableIntMsg=TRUE;
		//MpuStatus.word=InputStatusEx(0);
		//if (MpuStatus.bit.INTFLAG)			// if INTFLAG is not low, 
		//{									// int message may not come
			SendCmdEx(0, 0, CMD_INT_CLEAR);
		//}
	}
	else
	{
		// Notify VxD not to send message to this hWnd
		// Normally you should diable message here after you close all timer and extint
		// and be sure all message disposed and intflag is cleared
		if (EnableIntMsg(FALSE))
		{
			CheckDlgButton(IDC_ENABLEMSG, TRUE);
			return;	// fail
		}
		bEnableIntMsg=FALSE;
	}
}

void CRobotTimIntDlg::OnEnablegraph() 
{
	m_bEnableGraph = !m_bEnableGraph;
}

void CRobotTimIntDlg::OnExtIntEdge0() 
{
	OnExtIntEdge(0);
}
void CRobotTimIntDlg::OnExtIntEdge1() 
{
	OnExtIntEdge(1);
}
void CRobotTimIntDlg::OnExtIntEdge2() 
{
	OnExtIntEdge(2);
}
void CRobotTimIntDlg::OnExtIntEdge3() 
{
	OnExtIntEdge(3);
}

void CRobotTimIntDlg::OnExtIntPolarity0() 
{
	OnExtIntPolarity(0);
}
void CRobotTimIntDlg::OnExtIntPolarity1() 
{
	OnExtIntPolarity(1);
}
void CRobotTimIntDlg::OnExtIntPolarity2() 
{
	OnExtIntPolarity(2);
}
void CRobotTimIntDlg::OnExtIntPolarity3() 
{
	OnExtIntPolarity(3);
}

void CRobotTimIntDlg::OnExtIntEdge(int ch)
{
	SendCmdDWDataEx(0, ch, CMD_INT_MODE, IsDlgButtonChecked(IDC_EXT_INT_EDGE0+ch));
}

void CRobotTimIntDlg::OnExtIntPolarity(int ch)
{
	SendCmdDWDataEx(0, ch, CMD_INT_POLARITY, IsDlgButtonChecked(IDC_EXT_INT_POLARITY0+ch));
}
