#ifndef	__RIBDEF_H__
#define	__RIBDEF_H__

#ifdef	__cplusplus
extern "C"{
#endif	//__cplusplus
#if	0
}
#endif

#if defined(VXD_DRIVER)
#pragma message ("VXD_DRIVER definition is found.  build .vxd driver.")
#include "RibVxd.inc"
#elif defined(JWRIB_NT_DRIVER)
#pragma message ("JWRIB_NT_DRIVER definition is found.  build .sys driver.")
//#include <WTYPES.h>
#elif defined(WIN32)
#include <WTYPES.h>
#include <conio.h>
#else
//#include <linux/types.h>
#endif	//VXD_DRIVER

//#define	RIB_IO_DEBUG				//disable this line when make released code
//#define	RIB_AD_DEBUG				//disable this line when make released code
//#define	RIB_DA_DEBUG				//disable this line when make released code
//#define	RIB_DEBUG					//disable this line when make released code

#if	(!defined(VXD_DRIVER) && !defined(WIN32)) || defined(JWRIB_NT_DRIVER)
//typedef unsigned long		DWORD;
//typedef unsigned int		uint;
typedef unsigned int UINT;

#ifndef _BYTE_DEFINED
#define _BYTE_DEFINED

typedef unsigned char		BYTE;

#endif // !_BYTE_DEFINED
#ifndef _WORD_DEFINED
#define _WORD_DEFINED
typedef unsigned short WORD;

#endif // !_WORD_DEFINED
typedef	int				BOOL;
/*
#ifndef	TRUE
#undef	TRUE
#endif
#define	TRUE			1
#ifdef	FALSE
#undef	FALSE
#endif
#define	FALSE			0
#endif*/
#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif // !FALSE

#ifndef _LONG_DEFINED
#define _LONG_DEFINED
typedef long LONG;

#endif // !_LONG_DEFINED
#ifndef _DWORD_DEFINED
#define _DWORD_DEFINED
typedef unsigned long DWORD;

#endif // !_DWORD_DEFINED

typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef DWORD ULONG;
#endif	//!defined(VXD_DRIVER) && !defined(WIN32)
/******************************************************************************/
//#define	JWRIBPCI_HARDWARE_VERSION	0x0200			// v2.00
//#define	JWRIBPCI_HARDWARE_VERSION	0x0201			// v2.01, no enc initialization. <20020917>
//#define	JWRIBPCI_HARDWARE_VERSION	0x0202			// v2.02, PWM:6bit Clock, 10bit Duty. <20021220>
#define	JWRIBPCI_HARDWARE_VERSION	0x0300			// v3.00, PIO:32ch, PWM:clock/duty, AD/DA diff 0.1V, IRQ->APIC(not through ALTERA). <20030414>

// V0100: Original release version.  PWM rate(8bit), duty(N/A), Zphase was incorrect
// V0101: Added PWM duty(0-100) function, PWM rate(156~40KHz)
// V0102: PWM rate-17 bit, duty(N/A), the ENC Zphase registers were cancelled.
// V0103: PWM duty-8bit(0-255)

// V0200: <200208>
// V0201: <200209>.  do not intialize enc to zero.
// V0202: <200212>.  PWM_DATA:  CLOCK: b0--b5; DUTY:b6--b15

// V0300: <20030422>. 
/******************************************************************************/

#define	MAX_RIB_NUM			4	//Support as many as 4 boards


#if	JWRIBPCI_HARDWARE_VERSION==0x0201
#define	_RIB_NO_ENC_INIT
#endif

//////////////////////////////////////////////////////////////////////////////
//  IMPORTANT:	COMMAND definition in RIBPCI is different with in RIBISA	//
//////////////////////////////////////////////////////////////////////////////

////////////////////////////  COMMAND definition  ////////////////////////////
#define CMD_ACTION_MASK		0xFF00	//  1111 1111 0000 0000
#define CMD_CHANNEL_MASK	0x00FF	//  0000 0000 1111 1111
#define CMD_ACTION_SHIFT	8		//	R/LShift 8 bits
#define CMD_GROUP_MASK		(0xF000>>CMD_ACTION_SHIFT)	//  1111 1111 0000 0000

#define CMD_SYSPART			0x00
#define CMD_SYS_GETVER		0x0F

//  AD part
#define CMD_ADPART			0x10
#define CMD_AD_READ			0x10	//  Read AD conversion result
#define CMD_AD_START		0x11	//  Start AD conversion
#define CMD_AD_STOP			0x12	//  Start AD conversion
#define CMD_AD_READBUF		0x13	//  Read auto mode data buffer
#define CMD_AD_CLEARBUF		0x14	//  clear data buffer

#define CMD_AD_BUFSTA		0x15	//  Read auto mode data buffer status
#define CMD_AD_CHECK		0x17	//  Read AD data(no conv)

//  DA part
#define CMD_DAPART			0x20
#define CMD_DA_WRITE		0x20	//  Write DA data
#define CMD_DA_START		0x21	//  Write DA data
#define CMD_DA_STOP			0x22	//  Write DA data
#define CMD_DA_WRITEBUF		0x23	//  Write auto mode data buffer
#define CMD_DA_CLEARBUF		0x24	//  clear data buffer

#define CMD_DA_CHECK		0x27	//  Read DA data(no conv)
#define CMD_DA_BUFSTA		0x25	//  Read auto mode data buffer status

//  PWM part
#define CMD_PWMPART			0x30
#define CMD_PWM_START		0x30	//  Enable output	// new
#define CMD_PWM_STOP		0x31	//  Disable output
#define CMD_PWM_RATE		0x32	//  Set frequency: 1MHz--62KHz (16Mz/x 0x100-x=0xF0--0x00)
#define CMD_PWM_DUTY		0x33	//  Duty: 0 -- 255 (0%--100%)  HW0101, >=0200 : 0 -- 100 (0%--100%)

//  ENC part
#define CMD_ENCPART			0x40
#define CMD_ENC_START		0x40	//  
#define CMD_ENC_STOP		0x41	//  
#define CMD_ENC_MODE		0x42	//  Set X1,2,4, Pulse
#define CMD_ENC_READ		0x43	//  Read counter data
#define CMD_ENC_CLEAR		0x44	//  ENC clear
#define CMD_ENC_ZPHASE		0x45	//  ENC clear
#define CMD_ENC_ZPOLE		0x46	//  ENC clear
//#define CMD_ENC_INPUTMODE	0x43	//  Input mode: single/dual
//#define CMD_ENC_CLEARMODE	0x44	//  Clear mode: Edge/Level
#define CMD_ENC_WRITE		0x47	//  Write counter data
#define CMD_ENC_SET			CMD_ENC_WRITE	//  Write counter data
//#define CMD_ENC_ZENABLE		0x48	//  ENC clear
//#define CMD_ENC_READSTATUS	0x4800	//  Read ENC chip status (chipid)
#define	ENC_MODE_PULSE          0
#define	ENC_MODE_X1     	1
#define	ENC_MODE_X2             2
#define	ENC_MODE_X4	        3

//  PIO part
#define CMD_PIOPART			0x50
#define CMD_PIO_READ		0x50	//  Read PIO 
#define CMD_PIO_WRITE		0x51	//  Write PIO
#define CMD_PIO_SET			0x52	//  Set PIO 1
#define CMD_PIO_CLEAR		0x53	//  Set PIO 0

//  INT part
#define CMD_INTPART			0x60
#define CMD_INT_ENABLE		0x60	//  Enable INT
#define CMD_INT_DISABLE		0x61	//  Disable INT
#define CMD_INT_MODE		0x62	//  Set INT mode: Edge/Level
#define CMD_INT_CLEAR		0X63	//	per bit represent a channel
#define CMD_INT_POLARITY	0x64	//  

//   ITU part	//  ch: 0-4
#define CMD_TMPART			0x70
#define CMD_TM_START		0x70	//  Start:1, OVIE:1, OVF:0
#define CMD_TM_STOP			0x71	//  Start:0, OVIE:0, OVF:0

#define CMD_TM_RDSTATUS		0x73
#define CMD_ITU_START		0x75
#define CMD_ITU_STOP		0x76	//  Enable INT
#define CMD_ITU_RDSTATUS	0x77	//  Set INT mode: E
#define CMD_ITU_RDCURCNT	0x7A	//	Read current count value
#define CMD_ITU_RDINICNT	0x7B	//	Read initial count value


#define CMD_TEST_NINTDA		0xC0
#define CMD_TEST_INTDA		0xC1
#define CMD_TEST_NINTAD		0xC8
#define CMD_TEST_INTAD		0xC9


#define CMD_ADVANCE_CMD		0xE0	//  Advanced command flag

//   MPU <=> PC use		//  These commands may destroy the current progress, please be attention
#define CMD_MPPART			0xF0
#define CMD_MP_CLRHBYTE		0xF0
//#define CMD_MP_CLRREADY		0xF1		// ISA: read a data to clear READY
#define CMD_MP_CLRERR		0xF2
#define CMD_MP_CLRINTF		0xF3
#define CMD_MP_SETREADY		0xF6
#define CMD_MP_SETBUSY		0xF7
#define CMD_MP_CLRBUSY		0xF8
#define CMD_MP_SETSTATUS	0xF9
#define CMD_MP_RESET		0xFA
#define CMD_MP_TEST			0xFB
#define CMD_MP_HWRESET		0xFF	//  ISA: Reset 3003 and all other chips	// PCI: restore default values.
#define	CMD_MP_ALLRESET		CMD_MP_HWRESET



#define MAXEXTTIMER	 2

//#define MAX_RIB_EXT_INT	4
#define INT_EXT1		0x01
#define INT_EXT2		0x02
#define INT_EXT3		0x03
#define INT_EXT4		0x04

#ifdef	JWRIBISA
#define	INT_TM1			0x10
#define	INT_TM2			0x11

#define INT_ENCZ01		0x20
#define INT_ENCZ02		0x21
#define INT_ENCZ03		0x22
#define INT_ENCZ04		0x23
#define INT_ENCZ05		0x24
#define INT_ENCZ06		0x25
#define INT_ENCZ07		0x26
#define INT_ENCZ08		0x27
#define INT_ENCZ09		0x28
#define INT_ENCZ10		0x29
#define INT_ENCZ11		0x2A
#define INT_ENCZ12		0x2B
#define INT_ENCZ13		0x2C
#define INT_ENCZ14		0x2D
#define INT_ENCZ15		0x2E
#define INT_ENCZ16		0x2F


#define	INT_AD			0x30
#define	INT_DA			0x31

#define ADTIMEOUT		20	// Max A/D conversion waiting time(loop)
#define MAXINTARR		10	// Max Int type Array Length

//#define SETBUSYFLAG   Status_BUSYMASK=0;  Status.bit.BUSY=1;	*STA_ADR=Status.word;	Status_BUSYMASK=1;
//#define CLRBUSYFLAG	  Status_BUSYMASK=0;  Status.bit.BUSY=0;	*STA_ADR=Status.word;	Status_BUSYMASK=1;
//#define SETREADYFLAG  Status_READYMASK=0; Status.bit.READY=1;	*STA_ADR=Status.word;	Status_READYMASK=1;
//#define CLRREADYFLAG  Status_READYMASK=0; Status.bit.READY=0;	*STA_ADR=Status.word;	Status_READYMASK=1;

#endif
//  ####################################################################
#define	RIB_MAXADCH			16
#define	RIB_MAXDACH			16
#define	RIB_MAXENCCH		16
#if	(JWRIBPCI_HARDWARE_VERSION==0x0202)
#define	RIB_MAXPWMCH		15
#else
#define	RIB_MAXPWMCH		16
#endif
#if	(JWRIBPCI_HARDWARE_VERSION<0x0300)
#define	RIB_MAXPIOINCH		64
#define	RIB_MAXPIOOUTCH		64
#else
#define	RIB_MAXPIOINCH		32
#define	RIB_MAXPIOOUTCH		32
#endif
#define	RIB_PIO_INCHPERGRP	16
#define	RIB_PIO_OUTCHPERGRP	16
#define	RIB_MAXPIOINGRP		(RIB_MAXPIOINCH/RIB_PIO_INCHPERGRP)
#define	RIB_MAXPIOOUTGRP	(RIB_MAXPIOOUTCH/RIB_PIO_OUTCHPERGRP)

#define	ADMAXVAL			 2047
#define	ADMINVAL			(-2048)
#define	HW_ADMAXVAL			(ADMAXVAL-ADMINVAL)
#define	HW_ADMINVAL			0
#define	DAMAXVAL			 2047
#define	DAMINVAL			(-2048)

#if	(JWRIBPCI_HARDWARE_VERSION>=0x0200)
#define	HW_DAMAXVAL			 4095
#define	HW_DAMINVAL			(-4096)
#else
#error  "PCB too old"
#define	HW_DAMAXVAL			DAMAXVAL
#define	HW_DAMINVAL			DAMINVAL
#endif//JWRIBPCI_HARDWARE_VERSION

#define PWMMINRATEDVAL		0x00
#if JWRIBPCI_HARDWARE_VERSION==0x0102
#define PWMMAXRATEDVAL		0x1FFFF
#elif JWRIBPCI_HARDWARE_VERSION==0x0202
#define	PWM_MAX_CLOCK		0x3F
#define	PWM_CLOCK_MASK		0x3F
#define	PWM_CLOCK_SHIFT		0
#define	PWM_DATA_CLOCK_MASK	(PWM_CLOCK_MASK<<PWM_CLOCK_SHIFT)
#define PWMMAXRATEDVAL		PWM_MAX_CLOCK
#else
#define PWMMAXRATEDVAL		0xFF
#endif

#define PWMMINDUTY			0
#if	JWRIBPCI_HARDWARE_VERSION==0x0101
#define PWMMAXDUTY			100
#elif JWRIBPCI_HARDWARE_VERSION==0x0103
#define PWMMAXDUTY			255
#elif JWRIBPCI_HARDWARE_VERSION==0x0202
#define PWMMAXDUTY			0x3FF	//1023
#define	PWM_DUTY_SHIFT		6
#define	PWM_DUTY_MASK		0x3FF
#define	PWM_DATA_DUTY_MASK	(0x3FF<<PWM_DUTY_SHIFT)
#else //JWRIBPCI_HARDWARE_VERSION==0x100, 0x102
#define PWMMAXDUTY			100
#endif

#define ENCMINCOUNT			0
#define ENCMAXCOUNT			0xFFFFFF


#if JWRIBPCI_HARDWARE_VERSION==0x0102
#define	RibGetPwmRate	JWRIBPCIV102_GetPwmRate
#elif JWRIBPCI_HARDWARE_VERSION==0x0101 || JWRIBPCI_HARDWARE_VERSION>=0x0200
#define	RibGetPwmRate	JWRIBPCIV101_GetPwmRate
#elif JWRIBPCI_HARDWARE_VERSION==0x0103
#define	RibGetPwmRate	JWRIBPCIV103_GetPwmRate
#elif JWRIBPCI_HARDWARE_VERSION==0x0202
#define	RibGetPwmRate	JWRIBPCIV202_GetPwmRate
#else
#define	RibGetPwmRate	JWRIBPCIV100_GetPwmRate
#endif	//JWRIBPCI_HARDWARE_VERSION
//inline double RibGetPwmRate(int d){62.500 / (double)(16-d);}							//RIB_ISA v1.xx
#if	defined(VXD_DRIVER)
inline double JWRIBPCIV100_GetPwmRate(BYTE d){return 4000000.0 / (double)(0x100-d);}	//HW v1.00
inline double JWRIBPCIV101_GetPwmRate(BYTE d){return 40000.0 / (double)(0x100-d);}		//HW v1.01
inline double JWRIBPCIV102_GetPwmRate(DWORD d){return 1000000.0 / (double)((PWMMAXRATEDVAL+1)-d);}		//HW v1.02
inline double JWRIBPCIV103_GetPwmRate(BYTE d){return 62500.0 / (double)(0x100-d);}		//HW v1.03
inline double JWRIBPCIV202_GetPwmRate(BYTE d){return 4000000.0 / (double)((PWMMAXRATEDVAL+1)-d);}		//HW v2.02
inline double JWRIBPCIV300_GetPwmRate(BYTE d){return JWRIBPCIV202_GetPwmRate(d);}
#else
#define JWRIBPCIV100_GetPwmRate(d)	(4000000.0 / (double)(0x100-d))	//HW v1.00
#define JWRIBPCIV101_GetPwmRate(d)	(40000.0 / (double)(0x100-d))		//HW v1.01
#define JWRIBPCIV102_GetPwmRate(d)	(1000000.0 / (double)((PWMMAXRATEDVAL+1)-d))		//HW v1.02
#define JWRIBPCIV103_GetPwmRate(d)	(62500.0 / (double)(0x100-d))		//HW v1.03
#define	JWRIBPCIV202_GetPwmRate(d)	(4000000.0 / (double)((PWMMAXRATEDVAL+1)-d))		//HW v2.02
#define	JWRIBPCIV300_GetPwmRate(d)	JWRIBPCIV202_GetPwmRate(d)
#endif

////////////////////////////////////////////////////////////////////////////////
typedef struct _RIB_INT_INFO
{
	DWORD	dwSize;
	WORD	wIntNum;
	WORD	wReserved1;
	DWORD	dwIntCount;
	DWORD	dwCallbackRet;
	DWORD	dwReserved1;						// store IntQueue address
}RIB_INT_INFO, *PRIB_INT_INFO;

#define	MAX_RIB_INTQ_BUFFER				100				// buffer
#define	RIB_INTQ_OFP_DISCARD_NEW		0				// Overflow Policy, 0: discard new
#define	RIB_INTQ_OFP_DISCARD_OLD		1				// Overflow Policy, 1: discard old
typedef struct _RIB_INT_QUEUE
{
	DWORD			dwMaxNum;		//=MAX_RIB_INTQ_BUFFER
	volatile DWORD	dwHead;
	volatile DWORD	dwRear;
	DWORD			dwOfPolicy;
	volatile WORD	awBuffer[MAX_RIB_INTQ_BUFFER];
	volatile DWORD	dwReserved1;
	volatile DWORD	dwReserved2;
}RIB_INT_QUEUE, *PRIB_INT_QUEUE;


#define	MIN_PC_IRQ	3
#define	MAX_PC_IRQ	127

typedef struct _JWRIBPCI_GENERAL_INFO
{
	DWORD	nRibs;				// rib num 0-3
	DWORD	dwDevMask;			// irq num
	WORD	RibID[MAX_RIB_NUM];	// rib serial num (SubSystemID)
}	JWRIBPCI_GENERAL_INFO, *PJWRIBPCI_GENERAL_INFO; // 16bytes

typedef struct _JWRIBPCI_DEV_INFO
{
	WORD	ribno;			// rib num 0-3
	WORD	irq;			// irq num
	WORD	RibVer;			// rib pci ver
	WORD	RibID;			// rib serial num (SubSystemID)
	DWORD	ioBase;			// base io address
	DWORD	ioLCR;			// base Apic LocalConfigurationRegister
}	JWRIBPCI_DEV_INFO, *PJWRIBPCI_DEV_INFO; // 16bytes

//#if defined(VXD_DRIVER) || defined(__KERNEL__)
typedef struct _JWRIBPCI_DEV
{
	BYTE	ribno;			// rib num 0-3
	BYTE	irq;			// irq num
	WORD	Revision;		// rib pci ver
	WORD	VendorID;		// 136Ch
	WORD	DeviceID;		// C0C0h
	WORD	SubVenID;		// 'J'+('W'<<8)
	WORD	SubSysID;		// rib serial num (SubSystemID)
	DWORD	ioBase;			// base io address
	DWORD	ioLCR;			// base Apic LocalConfigurationRegister
	DWORD	dwRibDevMask;	// each bit
}	JWRIBPCI_DEV, *PJWRIBPCI_DEV; // 24bytes
//#endif//defined(VXD_DRIVER) || defined(__KERNEL__)


#ifdef	__cplusplus
}	//extern "C"
#endif	//__cplusplus

#endif//__RIBDEF_H__
