#ifndef	__RIBDRVIO_H__
#define	__RIBDRVIO_H__

#ifdef	JWRIB_NT_DRIVER
#include "devioctl.h"
#endif

#if !defined(JWRIB_NT_DRIVER) && !defined(VXD_DRIVER)//compile for non-driver app
#include <tchar.h>
#endif

#ifdef	__cplusplus
extern "C"{
#if 0
}
#endif
#endif	//@__cplusplus


////////////////////////////////////////////////////////////////////////////////
#ifndef	CTL_CODE
#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
)
#endif

#ifndef	DEVICE_TYPE_FROM_CTL_CODE
//
// Macro to extract device type out of the device io control code
//
#define DEVICE_TYPE_FROM_CTL_CODE(ctrlCode)     (((ULONG)(ctrlCode & 0xffff0000)) >> 16)
#endif
#ifndef	FUNC_CODE_FROM_CTL_CODE
//
// Macro to extract device type out of the device io control code
//
#define FUNC_CODE_FROM_CTL_CODE(ctrlCode)     ((ULONG)((ctrlCode >> 2) & 0x00000fff))
#endif

#ifndef	FILE_DEVICE_UNKNOWN
#define FILE_DEVICE_UNKNOWN             0x00000022
#endif

#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3

#define FILE_ANY_ACCESS                 0
#define FILE_SPECIAL_ACCESS    (FILE_ANY_ACCESS)
#define FILE_READ_ACCESS          ( 0x0001 )    // file & pipe
#define FILE_WRITE_ACCESS         ( 0x0002 )    // file & pipe


////////////////////////////////////////////////////////////////////////////////
#define JWRIBPCI_DEVICE_NAME	_T("\\\\.\\JWRIBPCI")
#define NT_DEVICE_NAME			L"\\Device\\JWRIBPCI"
#define DOS_DEVICE_NAME			L"\\DosDevices\\JWRIBPCI"

#define	JWRIB_FIRST_FUNC_CODE			0x800
#define IOCTL_JWRIB_DIOC_FUNC0			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+0, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC1			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+1, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC2			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+2, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC3			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+3, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC4			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+4, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define IOCTL_JWRIB_DIOC_FUNC5			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+5, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define IOCTL_JWRIB_DIOC_FUNC6			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+6, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC7			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+7, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define IOCTL_JWRIB_DIOC_FUNC8			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+8, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC9			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+9, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC10			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+10, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC11			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+11, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC12			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+12, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC13			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+13, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC14			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+14, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC15			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+15, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC16			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+16, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC17			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+17, METHOD_BUFFERED, FILE_ANY_ACCESS )
#define IOCTL_JWRIB_DIOC_FUNC18			CTL_CODE( FILE_DEVICE_UNKNOWN, (JWRIB_FIRST_FUNC_CODE)+18, METHOD_BUFFERED, FILE_ANY_ACCESS )


#define	DIOC_FUNC0		IOCTL_JWRIB_DIOC_FUNC0
#define	DIOC_FUNC1		IOCTL_JWRIB_DIOC_FUNC1
#define	DIOC_FUNC2		IOCTL_JWRIB_DIOC_FUNC2
#define	DIOC_FUNC3		IOCTL_JWRIB_DIOC_FUNC3
#define	DIOC_FUNC4		IOCTL_JWRIB_DIOC_FUNC4
#define	DIOC_FUNC5		IOCTL_JWRIB_DIOC_FUNC5
#define	DIOC_FUNC6		IOCTL_JWRIB_DIOC_FUNC6
#define	DIOC_FUNC7		IOCTL_JWRIB_DIOC_FUNC7
#define	DIOC_FUNC8		IOCTL_JWRIB_DIOC_FUNC8
#define	DIOC_FUNC9		IOCTL_JWRIB_DIOC_FUNC9
#define	DIOC_FUNC10		IOCTL_JWRIB_DIOC_FUNC10
#define	DIOC_FUNC11		IOCTL_JWRIB_DIOC_FUNC11
#define	DIOC_FUNC12		IOCTL_JWRIB_DIOC_FUNC12
#define	DIOC_FUNC13		IOCTL_JWRIB_DIOC_FUNC13
#define	DIOC_FUNC14		IOCTL_JWRIB_DIOC_FUNC14
#define	DIOC_FUNC15		IOCTL_JWRIB_DIOC_FUNC15
#define	DIOC_FUNC16		IOCTL_JWRIB_DIOC_FUNC16
#define	DIOC_FUNC17		IOCTL_JWRIB_DIOC_FUNC17
#define	DIOC_FUNC18		IOCTL_JWRIB_DIOC_FUNC18


//ISAv1.00	//PCIv1.00
#define	RIB_GET_VXD_VERSION			DIOC_FUNC0
//#define RIB_GET_IRQ_NUM				DIOC_FUNC1
#define RIB_GET_GENERAL_INFO		DIOC_FUNC1
#define RIB_SET_HWND_MSG			DIOC_FUNC2
#define RIB_ENABLE_INT_MESSAGE		DIOC_FUNC3
#define RIB_GET_BASE_ADR			DIOC_FUNC4
#define RIB_GET_VXD_INFO			DIOC_FUNC5
#define RIB_GET_VXD_EXTRA_INFO		DIOC_FUNC6
#define RIB_POST_INT_MESSAGE		DIOC_FUNC7
#define RIB_GET_VXD_DEBUG_INFO		DIOC_FUNC8
#define RIB_FREE_IRQ_HANDLE			DIOC_FUNC9
//ISAv1.01
#define RIB_TEST_VXD_CALLBACK		DIOC_FUNC10
#define RIB_SET_VXD_CALLBACK		DIOC_FUNC11
//PCIv1.00
#define IOCTL_RIB_SEND_CMD_EX		DIOC_FUNC12
#define IOCTL_RIB_OUTPUT_DATA_EX	DIOC_FUNC13
#define IOCTL_RIB_INPUT_DATA_EX		DIOC_FUNC14
#define IOCTL_RIB_INPUT_STATUS_EX	DIOC_FUNC15

#define IOCTL_RIB_GET_INFO_EX		DIOC_FUNC18

#ifndef	_RIB_DRV_CALLBACK_DEFINED
#define	_RIB_DRV_CALLBACK_DEFINED
typedef int (RIB_DRV_CALLBACK)(USHORT wIntNo, BOOL* bEnableMessage, void* pUserData, ULONG nUserDataSize);

#define	RIBVXDCALLBACK				RIB_DRV_CALLBACK
#endif	//_RIBDRVCALLBACK_DEFINED


//#define MAX_PCI_BUSES				256
//#define GP_MAX_INSERTION_STRINGS	20

//#define GP_4000PCI_VENDORID		0x136C
//#define GP_4000PCI_DEVICEID		0x0001

#define GP_PCI_BYTE_IO		0x0000
#define GP_PCI_WORD_IO		0x0001
#define GP_PCI_DWORD_IO		0x0002

#define	RIB_PCI_MAX_PORTS		2

#define	JWRIBPCI_DEBUG_BUF_NUM	64


#ifdef	__cplusplus
}	//extern "C"
#endif

#endif	//__RIBDRVIO_H__
