// RobotCtrlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RobotCtrl.h"
#include "RobotCtrlDlg.h"
///////////////////////////////
#include "hardware.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	JW_RIB_TIMER			10
#define	JW_RIB_TIMER_ELAPSE		100	//ms
UINT WM_IrqMsg = RegisterWindowMessage("WM_ROBOT_PCI_IRQ");

DECLARE_RIB_PCI_BASEADR;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRobotCtrlDlg dialog

CRobotCtrlDlg::CRobotCtrlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRobotCtrlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRobotCtrlDlg)
	m_nPcIrqNum = 3;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	pRobotAdDaDlg = NULL;
	pRobotPwmEncDlg = NULL;
	pRobotPioDlg = NULL;
}

void CRobotCtrlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRobotCtrlDlg)
	DDX_Control(pDX, IDC_STALEDIT, m_StaLEdit);
	DDX_Control(pDX, IDC_STAHEDIT, m_StaHEdit);
	DDX_Text(pDX, IDC_PCIRQNUMEDIT, m_nPcIrqNum);
	DDV_MinMaxUInt(pDX, m_nPcIrqNum, 3, 15);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRobotCtrlDlg, CDialog)
	//{{AFX_MSG_MAP(CRobotCtrlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADDABUTTON, OnAdDa)
	ON_BN_CLICKED(IDC_PWMENCBUTTON, OnPwmEnc)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_PIOBUTTON, OnPio)
	ON_BN_CLICKED(IDC_Reset, OnReset)
	ON_BN_CLICKED(IDC_MISCBUTTON, OnMisc)
	ON_EN_KILLFOCUS(IDC_CMDADREDIT, OnKillfocusCmdadredit)
	ON_EN_KILLFOCUS(IDC_PCIRQNUMEDIT, OnKillfocusPcirqnumedit)
	ON_BN_CLICKED(IDC_MPUTEST, OnMpuTest)
	ON_BN_CLICKED(IDC_INTTIMBUTTON, OnInttimbutton)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_EN_KILLFOCUS(IDC_RIBID_EDIT, OnKillFocusRibIDEdit)
	ON_EN_KILLFOCUS(IDC_RIBNO_EDIT, OnKillFocusRibNoEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRobotCtrlDlg message handlers

BOOL CRobotCtrlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	////////////////////////////////////////////////////////////////////////////
	pRobotAdDaDlg = NULL;
	pRobotPwmEncDlg = NULL;
	pRobotPioDlg = NULL;
	pRobotTimIntDlg = NULL;
	pRobotMiscDlg = NULL;

	RibInitial();
	m_uiTimerId = SetTimer(JW_RIB_TIMER, JW_RIB_TIMER_ELAPSE, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRobotCtrlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRobotCtrlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CRobotCtrlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRobotCtrlDlg::OnAdDa() 
{
	_ASSERT(!pRobotAdDaDlg);
	pRobotAdDaDlg = new CRobotAdDaDlg;
	_ASSERT(pRobotAdDaDlg);
	pRobotAdDaDlg->DoModal();
	delete pRobotAdDaDlg;
	pRobotAdDaDlg = NULL;

}
void CRobotCtrlDlg::OnPwmEnc() 
{
	_ASSERT(!pRobotPwmEncDlg);
	pRobotPwmEncDlg = new CRobotPwmEncDlg;
	_ASSERT(pRobotPwmEncDlg);
	pRobotPwmEncDlg->DoModal();
	delete pRobotPwmEncDlg;
	pRobotPwmEncDlg = NULL;
}
void CRobotCtrlDlg::OnPio() 
{
	_ASSERT(!pRobotPioDlg);
	pRobotPioDlg = new CRobotPioDlg;
	_ASSERT(pRobotPioDlg);
	pRobotPioDlg->DoModal();
	delete pRobotPioDlg;
	pRobotPioDlg = NULL;
}

void CRobotCtrlDlg::OnTimer(UINT nIDEvent) 
{
//return;
	// TODO: Add your message handler code here and/or call default
	if (pRobotAdDaDlg && pRobotAdDaDlg->m_bInitialized)
		pRobotAdDaDlg->UpdateMpuData();
	
	if (pRobotPwmEncDlg && pRobotPwmEncDlg->m_bInitialized)
		pRobotPwmEncDlg->UpdateMpuData();
	
	if (pRobotPioDlg && pRobotPioDlg->m_bInitialized)
		pRobotPioDlg->UpdateMpuData();

	UpdateStatus();
	CDialog::OnTimer(nIDEvent);
}


void CRobotCtrlDlg::OnReset() 
{
	MpuReset();	
}

void CRobotCtrlDlg::OnMisc() 
{
	_ASSERT(!pRobotMiscDlg);
	pRobotMiscDlg = new CRobotMiscDlg;
	_ASSERT(pRobotMiscDlg);
	pRobotMiscDlg->DoModal();
	delete pRobotMiscDlg;
	pRobotMiscDlg = NULL;
}

void CRobotCtrlDlg::RibInitial()
{
	// This routine show various ways to get rib info

	char str[32];
	WORD curData;

	if (!MpuReset())
	{
		SetDlgItemText(IDC_RIB_STATUS, "PCI board is not found or not installed properly!");
		return;
	}

	curData=GetRegAdr();
	RIB_PCI_BASEADR[0] = curData;
	((CEdit*)GetDlgItem(IDC_CMDADREDIT))->LimitText(6);
	sprintf(str, "0x%04X", curData);
	SetDlgItemText(IDC_CMDADREDIT, str);

	curData=GetIrqNo();
	((CEdit*)GetDlgItem(IDC_PCIRQNUMEDIT))->LimitText(2);
	SetDlgItemInt(IDC_PCIRQNUMEDIT, curData, FALSE);

	SetDlgItemInt(IDC_RIBNO_EDIT, 0);
	SetDlgItemInt(IDC_RIBID_EDIT, GetRibIDEx(0));

	JWRIBPCI_DEV_INFO	devinfo;
	if (GetRibInfoEx(0, &devinfo))	// GetRibInfoEx can get almost all rib info
	{
		wsprintf(str, "0x%04X", devinfo.ioLCR);
		SetDlgItemText(IDC_BASEPCI_EDIT, str);
		wsprintf(str, "%04X", devinfo.RibVer);
		SetDlgItemText(IDC_RIBVER_EDIT, str);
	}
}
// and at time, we should 
void CRobotCtrlDlg::OnKillfocusCmdadredit() 
{
	UINT uiCurAdr, uiAdr;
	char str[32]={'0', 'x'};
	char *ptr;

	uiCurAdr = GetRegAdr();
	GetDlgItemText(IDC_CMDADREDIT, str+2, 28);
	uiAdr = strtol(str+2, &ptr, 16);
	if (strlen(ptr) || (uiAdr>0x10000) || uiAdr&0x01)
	{
		sprintf(str, "0x%X", uiCurAdr);
		SetDlgItemText(IDC_CMDADREDIT, str);
		MessageBeep(-1);
	}
	else
	{
		if ( str[2]!='0' || ((str[3]!='x')&&(str[3]!='X')) )
		{
			SetDlgItemText(IDC_CMDADREDIT, str);
		}
	}
}

void CRobotCtrlDlg::OnKillfocusPcirqnumedit() 
{
	//UINT irqbak;
	//irqbak=m_nPcIrqNum;
	//if (UpdateData())
	//{
	//	if (SetIrqNoEx(0, m_nPcIrqNum))
	//	{
	//		m_nPcIrqNum=irqbak;
	//		SetDlgItemInt(IDC_PCIRQNUMEDIT, irqbak);
	//		MessageBeep(-1);
	//	}
	//}
}

void CRobotCtrlDlg::OnMpuTest()
{
	Sleep(100);
	if (MpuTest())
		SetDlgItemText(IDC_MPUTESTSTA, "OK.");
	else
	{
		SetDlgItemText(IDC_MPUTESTSTA, "Fail!");
		MessageBeep(-1);
	}
	SetDlgItemInt(IDC_WAIT1MSLOOPSEDIT, GetWait1msLoops(0, GetRegAdrEx(0)), FALSE);
	SetDlgItemInt(IDC_WAIT1MSIOLOOPSEDIT, GetWait1msLoops(1, GetRegAdrEx(0)), FALSE);
}

void CRobotCtrlDlg::OnInttimbutton() 
{
	pRobotTimIntDlg = new CRobotTimIntDlg(this);
	pRobotTimIntDlg->DoModal();
	delete pRobotTimIntDlg;
	pRobotTimIntDlg = NULL;
}

void CRobotCtrlDlg::UpdateStatus()
{
	return;
/*	static UINT databak=0xFFFFFFFF;
	WORD data;
	char str[32];
	int i;

	data = InputStatusEx(0);
	if (data==databak)
		return;
	databak = data;
	for (i=0; i<8; i++)
	{
		str[i*2]=' ';
		str[i*2+1] = (data&0x8000)?'1':'0';
		data<<=1;
	}
	str[i*2]=0;
	m_StaHEdit.SetWindowText(str);
	for (i=0; i<8; i++)
	{
		str[i*2]=' ';
		str[i*2+1] = (data&0x8000)?'1':'0';
		data<<=1;
	}
	str[i*2]=0;
	m_StaLEdit.SetWindowText(str);*/
}

void CRobotCtrlDlg::OnButton1() 
{
	DWORD	dw;
	int		i=0;
	while(i++<1000000)
	{
		if (!EncRead(0, &dw) || (dw!=0))
			DebugBreak();
	}
}

void CRobotCtrlDlg::OnButton2() 
{
	DWORD dwRet=0, dwBytesRet=0;
	DWORD dwInBuf[2]={0};
	DWORD dwOutBuf[6]={0};
	HANDLE	hDev;

	if (INVALID_HANDLE_VALUE==(hDev=GetVxdHandle()))		return;
	if ( ! DeviceIoControl(
					hDev,
					RIB_GET_VXD_DEBUG_INFO,
					dwInBuf,	sizeof(DWORD),
					dwOutBuf,	sizeof(DWORD)*6,
					&dwBytesRet,NULL)
		|| (dwBytesRet!=sizeof(DWORD)*6)
		)
	{
		dwRet = GetLastError();
		_ASSERT(0);	//DebugBreak();
	}

	TCHAR buf[256];
	wsprintf(buf, _T("%08lX, %08lX, %08lX, %08lX, %08lX, %08lX"), 
			dwOutBuf[0], dwOutBuf[1], dwOutBuf[2], dwOutBuf[3], dwOutBuf[4], dwOutBuf[5]);
	MessageBox(buf);
}

BOOL CRobotCtrlDlg::DestroyWindow() 
{
	if (m_uiTimerId)
	{
		ASSERT(m_uiTimerId==JW_RIB_TIMER);
		BOOL bRet = KillTimer(m_uiTimerId);
		_ASSERT(bRet);
	}

	if (pRobotAdDaDlg)
	{
		delete pRobotAdDaDlg;
		pRobotAdDaDlg = NULL;
	}

	if (pRobotPwmEncDlg)
	{
		delete pRobotPwmEncDlg;
		pRobotPwmEncDlg = NULL;
	}

	if (pRobotPioDlg)
	{
		delete pRobotPioDlg;
		pRobotPioDlg = NULL;
	}

	if (pRobotMiscDlg)
	{
		delete pRobotMiscDlg;
		pRobotMiscDlg = NULL;
	}

	if (pRobotTimIntDlg)
	{
		delete pRobotTimIntDlg;
		pRobotTimIntDlg = NULL;
	}

	return CDialog::DestroyWindow();
}

BOOL CRobotCtrlDlg::PreTranslateMessage(MSG* pMsg) 
{
	HWND	hwndFocus;
	if ( (pMsg->message==WM_KEYDOWN) && (pMsg->wParam==VK_RETURN) )
	{
		hwndFocus = GetFocus()->GetSafeHwnd();
		if ( hwndFocus == GetDlgItem(IDC_RIBID_EDIT)->GetSafeHwnd() )
		{
			OnKillFocusRibIDEdit();
			return TRUE;
		}
		else if ( hwndFocus == GetDlgItem(IDC_RIBNO_EDIT)->GetSafeHwnd() )
		{
			OnKillFocusRibNoEdit();
			return TRUE;
		}		
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CRobotCtrlDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CRobotCtrlDlg::OnKillFocusRibIDEdit() 
{
	int		iRibNo, iRibID;
	BOOL	bOK=TRUE;
	TCHAR	szBuf[64];

	iRibID = GetDlgItemInt(IDC_RIBID_EDIT);
	if (iRibID<=0)
	{
		MessageBox("Invalid id value.");
		bOK=FALSE;
	}
	else
	{
		iRibNo=GetRibNoEx(iRibID);
		if ((UINT)iRibNo>=MAX_RIB_NUM)
		{
			MessageBox("board not found.");
			bOK=FALSE;
		}
		else
		{
			wsprintf(szBuf, "0x%04X", GetPciBaseAdr(iRibNo));
			SetDlgItemText(IDC_BASEADR_EDIT, szBuf);
			wsprintf(szBuf, "0x%04X", GetPciBaseLCR(iRibNo));
			SetDlgItemText(IDC_BASEPCI_EDIT, szBuf);

			SetDlgItemInt(IDC_IRQNO_EDIT,	GetIrqNoEx(iRibNo),	FALSE);
			SetDlgItemInt(IDC_RIBNO_EDIT,	(UINT)iRibNo,	FALSE);
			bOK=TRUE;
		}
	}
	if (!bOK)
		::SetFocus(GetDlgItem(IDC_RIBID_EDIT)->GetSafeHwnd());
}

void CRobotCtrlDlg::OnKillFocusRibNoEdit() 
{
	int		iRibNo, iRibID;
	BOOL	bOK=TRUE;
	TCHAR	szBuf[64];

	iRibNo = GetDlgItemInt(IDC_RIBNO_EDIT);
	if ((UINT)iRibNo>=MAX_RIB_NUM)
	{
		MessageBox("Invalid number value.");
		bOK=FALSE;
	}
	else
	{
		iRibID=GetRibIDEx(iRibNo);
		if (iRibID<=0)
		{
			MessageBox("board not found.");
			bOK=FALSE;
		}
		else
		{
			wsprintf(szBuf, "0x%04X", GetPciBaseAdr(iRibNo));
			SetDlgItemText(IDC_BASEADR_EDIT, szBuf);
			wsprintf(szBuf, "0x%04X", GetPciBaseLCR(iRibNo));
			SetDlgItemText(IDC_BASEPCI_EDIT, szBuf);

			SetDlgItemInt(IDC_IRQNO_EDIT, GetIrqNoEx(iRibNo), FALSE);
			SetDlgItemInt(IDC_RIBID_EDIT, (UINT)iRibID, FALSE);
			bOK=TRUE;
		}
	}
	if (!bOK)
		::SetFocus(GetDlgItem(IDC_RIBNO_EDIT)->GetSafeHwnd());
}
